﻿using System;

namespace David.Academy.ProgrammingInCSharp.CelestialBodies
{
	class CelestialBody
	{
		public CelestialBody(
			string name, double mass, double volume)
			: this(name, mass, volume, Shape.Random)
		{
		}

		public CelestialBody(
			string name, double mass, double volume, Shape shape)
		{
			if (string.IsNullOrEmpty(name))
			{
				throw new ArgumentException(
					"Името на небесно тяло не трябва да бъде празно.");
			}

			Name = name;
			Mass = mass;
			Volume = volume;
			Shape = shape;
		}

		public string Name { get; private set; }

		public double Mass { get; private set; }

		public double Volume { get; private set; }

		public Shape Shape { get; private set; }

		public void PrintToConsole()
		{
			Console.WriteLine(
				"{0}, {1}kg, {2}m3, {3}",
				Name, Mass, Volume, Shape);
		}
	}
}
