﻿using System;
using System.Drawing;

namespace David.Academy.ProgrammingInCSharp.CelestialBodies
{
	class Program
	{
		static void Main(string[] args)
		{
			try
			{
				Console.WriteLine("Въведете име на слънце:");
				string sunName = Console.ReadLine();
				Star sun = new Star(
					sunName, 2, 3, 12e+6, 6, Color.Yellow);
				Planet earth = new Planet(
					"Earth", 1.5, 5, Shape.Ellipsoid,
					sun, 6400, true, true);
				Satellite moon = new Satellite(
					"Moon", 0.5, 1, Shape.Spherical,
					earth, 150000);

				CelestialBody[] bodies = new CelestialBody[10];
				bodies[0] = sun;
				bodies[1] = earth;
				bodies[2] = moon;

				foreach (CelestialBody body in bodies)
				{
					if (body != null)
					{
						body.PrintToConsole();
						if (body is Star)
						{
							Star star = (Star)body;
							star.PrintToConsole();
						}
					}
				}
			}
			catch (ArgumentException ex)
			{
				Console.WriteLine(ex.Message);
			}

			Console.ReadLine();
		}
	}
}
