﻿using System;
using System.Drawing;

namespace David.Academy.ProgrammingInCSharp.CelestialBodies
{
	class Star : CelestialBody
	{
		public Star(
			string name, double mass, double volume,
			double radius, double brightness, Color color)
			: base(name, mass, volume, Shape.Spherical)
		{
			Radius = radius;
			Brightness = brightness;
			Color = color;
		}

		public double Radius { get; private set; }

		public double Brightness { get; private set; }

		public Color Color { get; private set; }

		public void PrintToConsole()
		{
			Console.WriteLine(
				"{0}km, brightness {1}, {2}",
				Radius, Brightness, Color);
		}
	}
}
