﻿using System;

namespace David.Academy.ProgrammingInCSharp.Delegates
{
	delegate int BinaryOperation(int x, int y);

	class Calculator
	{
		public void Calculate(int x, int y, char op, BinaryOperation operation)
		{
			Console.WriteLine(
				"{0} {1} {2} = {3}", x, op, y, operation(x, y));
		}
	}

	class Program
	{
		static void Main(string[] args)
		{
			Calculator calculator = new Calculator();

			BinaryOperation operation;
			char op;
			Console.Write("1 for sum, 2 for product:");
			string input = Console.ReadLine();
			if (input == "1")
			{
				operation = Sum;
				op = '+';
			}
			else if (input == "2")
			{
				operation = Product;
				op = '*';
			}
			else
				throw new Exception("Wrong input.");

			calculator.Calculate(3, 5, op, operation);
			Console.ReadLine();
		}

		public static int Sum(int x, int y)
		{
			return x + y;
		}

		public static int Product(int x, int y)
		{
			return x * y;
		}
	}
}
