﻿using System;

namespace David.Academy.ProgrammingInCSharp.Events
{
	delegate void NotificationHandler(object data);

	class Notifier
	{
		public void Notify(object data)
		{
			if (Notification != null)
				Notification(data);
		}

		public event NotificationHandler Notification;
		public event NotificationHandler OtherNotification;
	}

	class Program
	{
		static void Main(string[] args)
		{
			Notifier notifier = new Notifier();
			notifier.Notification +=
				new NotificationHandler(Notifier_Notification);
			notifier.Notification +=
				new NotificationHandler(Notifier_Notification2);
			notifier.Notify(42);
			notifier.Notify("meow");
			notifier.Notify(DateTime.Now);
			Console.ReadLine();
		}

		public static void Notifier_Notification(object data)
		{
			Console.WriteLine(
				"Received notification with data: {0}", data);
		}

		public static void Notifier_Notification2(object data)
		{
			Console.WriteLine(
				"Other notification handler with data: {0}", data);
		}
	}
}
