﻿using System;

namespace David.Academy.ProgrammingInCSharp.Library
{
	public class Book
	{
		private static Book[] _books;

		static Book()
		{
			_books = new Book[100];
		}

		public Book()
		{
			for (int i = 0; i < _books.Length; i++)
			{
				if (_books[i] == null)
				{
					_books[i] = this;
					break;
				}
			}
		}

		public Book(string title, string author, int year)
			: this()
		{
			Title = title;
			Author = author;
			Year = year;
		}

		public Book(
			string title, string author,
			int year, BookContent content)
			: this(title, author, year)
		{
			Content = content;
		}

		public static void PrintAllBooksToConsole()
		{
			foreach (Book book in _books)
			{
				if (book != null)
					book.PrintToConsole();
			}
		}

		public string Title { get; private set; }

		public string Author { get; set; }

		public int Year { get; set; }

		public BookContent Content { get; set; }

		public void InputFromConsole()
		{
			Console.Write("Book title: ");
			Title = Console.ReadLine();
			Console.Write("Book author: ");
			Author = Console.ReadLine();
			Console.Write("Year of release: ");
			Year = int.Parse(Console.ReadLine());

			Content.InputFromConsole();
		}

		public void PrintToConsole()
		{
			Console.WriteLine(
				"\"{0}\", {1}, {2}",
				Title,
				Author,
				Year);

			Content.PrintToConsole();
		}
	}
}
