﻿using System;

namespace David.Academy.ProgrammingInCSharp.Methods
{
	class Program
	{
		struct CourseInfo
		{
			public string CourseName;
			public int LectureNo;
			public string LectureName;
			public string LecturerName;
		}

		static CourseInfo GetCourseInfo()
		{
			return new CourseInfo
			{
				CourseName = "Programming in C#",
				LectureNo = 3,
				LectureName = "Functions and Methods",
				LecturerName = "Valery Dachev",
			};
		}

		// Prototype: GetCourseInfo(out string, out int, out string, out string)
		static void GetCourseInfo(out string courseName, out int lectureNo,
			out string lectureName, out string lecturerName)
		{
			courseName = "Programming in C#";
			lectureNo = 3;
			lectureName = "Functions and Methods";
			lecturerName = "Valery Dachev";
		}

		static void GetName(ref string name)
		{
			Console.Write("Currently logged in is {0}.", name);
			bool isThatTheLoggedUser = Confirm("Is that you? [y/n]");
			if (isThatTheLoggedUser)
			{
				return;
			}

			Console.WriteLine("Your name: ");
			name = Console.ReadLine();
		}

		static uint GetAge()
		{
			do
			{
				Console.Write("Your age: ");
				string line = Console.ReadLine();

				uint age;
				bool isValid = uint.TryParse(line, out age);
				if (isValid)
				{
					return age;
				}
			}
			while (true);
		}

		static void GetBio(ref string[] bio)
		{
			do
			{
				string line = Console.ReadLine();
				// ако не е въвел нищо, се връщаме обратно
				if (string.IsNullOrWhiteSpace(line))
					return;

				// ако няма създадена биография, създаваме такава
				if (bio == null)
				{
					// създаваме биография и добавяме първия ред в нея
					bio = new string[]
					{
						line,
					};
				}
				else
				{
					// създаваме нова биография с големина
					// по-голяма с единица от досегашната
					string[] t = new string[bio.Length + 1];
					// копираме старата биография в новата
					Array.Copy(bio, t, bio.Length);
					// добавяме новия ред като последен
					t[t.Length - 1] = line;
					// подменяме биографията с нова
					bio = t;
				}
			}
			while (true);
		}

		// Prototype: Confirm(string, params string[])
		static bool Confirm(string message = "[y/n] ?", params string[] lines)
		{
			foreach (string line in lines)
			{
				Console.WriteLine(line);
			}
			Console.Write(message);

			bool? isYes;
			do
			{
				ConsoleKeyInfo keyInfo = Console.ReadKey(true);
				switch (keyInfo.Key)
				{
					case ConsoleKey.Y:
						isYes = true;
						break;
					case ConsoleKey.N:
						isYes = false;
						break;
					default:
						isYes = null;
						break;
				}
			}
			while (isYes == null);

			Console.WriteLine();

			return isYes.Value;
		}

		static void SwapIntegers(ref int a, ref int b)
		{
			int t = a;
			a = b;
			b = t;
		}

		static void Main(string[] args)
		{
			string courseName;
			int lectureNo;
			string lectureName;
			string lecturerName;
			GetCourseInfo(out courseName, out lectureNo,
				out lectureName, out lecturerName);

			string studentName = "Valery Dachev";
			GetName(ref studentName);

			uint studentAge = GetAge();

			string[] bio = new string[]
			{
				"My name is " + studentName + ".",
			};
			GetBio(ref bio);

			bool wantsToExit;
			do
			{
				Console.WriteLine(@"
You're visiting course '{0}'.
It is lecture №{1} '{2}' by {3}.
Your name is {4}. Your age is {5}.",
					courseName, lectureNo, lectureName,
					lecturerName, studentName, studentAge);

				if (bio == null)
				{
					Console.WriteLine("You have no biography.");
				}
				else
				{
					Console.WriteLine("Your biography:");
					Console.WriteLine("===============");
					foreach (string line in bio)
					{
						Console.WriteLine(line);
					}
					Console.WriteLine("===============");
				}

				//wantsToExit = Confirm();
				wantsToExit = Confirm("Do you want to leave now?",
					"The course is extremely interesting.",
					"Please don't go!",
					"Really, really please!");
			}
			while (!wantsToExit);
		}
	}
}
