﻿using System;
using System.Numerics;

namespace David.Academy.ProgrammingInCSharp.Recursion
{
	class Program
	{
		static long RecursiveFactorial(uint n)
		{
			if (n <= 1)
				return 1;

			return n * RecursiveFactorial(n - 1);
		}

		static long Factorial(uint n)
		{
			long result = 1;
			for (int i = 1; i <= n; i++)
			{
				result = result * i;
			}

			return result;
		}

		static BigInteger BigFactorial(uint n)
		{
			BigInteger result = 1;
			for (int i = 1; i <= n; i++)
			{
				result = result * i;
			}

			return result;
		}
		static void Main(string[] args)
		{
			do
			{
				Console.Write("n = ");
				uint n = uint.Parse(Console.ReadLine());
				Console.WriteLine("n! = {0} (recursive)", RecursiveFactorial(n));
				Console.WriteLine("n! = {0} (iteration)", Factorial(n));
				Console.WriteLine("n! = {0} (big)", BigFactorial(n));
			}
			while (true);
		}
	}
}
